import es
import langlib
import popuplib

popup = popuplib.create("sm_popup_admin_match_names")
text = langlib.Strings("cstrike/addons/eventscripts/soccer_mod_2010/language/match/popup_admin_match_names.ini")
text_score = langlib.Strings("cstrike/addons/eventscripts/soccer_mod_2010/language/match/popup_admin_match_score.ini")

def load():
	load_variables()
	create_popup()

def load_variables():
	name = es.ServerVar("sm_match_default_name_t")
	es.set("sm_match_name_t", name)

	name = es.ServerVar("sm_match_default_name_ct")
	es.set("sm_match_name_ct", name)

	name = es.ServerVar("sm_match_default_name_t_abbr")
	es.set("sm_match_name_t_abbr", name)

	name = es.ServerVar("sm_match_default_name_ct_abbr")
	es.set("sm_match_name_ct_abbr", name)

def create_popup():
	line = "SOCCER MOD %s" % (text("title"))
	popup.addline(line)

	popup.addline(" ")

	name = es.ServerVar("sm_match_name_t")
	line = "->1. %s: %s" % (text("name_t"), name)
	popup.addline(line)

	name = es.ServerVar("sm_match_name_ct")
	line = "->2. %s: %s" % (text("name_ct"), name)
	popup.addline(line)

	name = es.ServerVar("sm_match_name_t_abbr")
	line = "->3. %s: %s" % (text("short_name_t"), name)
	popup.addline(line)

	name = es.ServerVar("sm_match_name_ct_abbr")
	line = "->4. %s: %s" % (text("short_name_ct"), name)
	popup.addline(line)

	line = "->5. %s" % (text("reset"))
	popup.addline(line)

	popup.addline(" ")

	line = "->9. %s" % (text("back"))
	popup.addline(line)

	popup.addline(" ")

	line = "->0. %s" % (text("close"))
	popup.addline(line)

	popup.select(1, name_t)
	popup.select(2, name_ct)
	popup.select(3, short_name_t)
	popup.select(4, short_name_ct)
	popup.select(5, reset_names)
	popup.submenu(6, "sm_popup_admin_match_names")
	popup.submenu(7, "sm_popup_admin_match_names")
	popup.submenu(8, "sm_popup_admin_match_names")
	popup.submenu(9, "sm_popup_admin_match")

def name_t(userid, choice, popupid):
	steamid = es.getplayersteamid(userid)
	exists = es.exists("key", "sm_keygroup_set", steamid)
	if exists == 0:
		es.keycreate("sm_keygroup_set", steamid)

	es.keysetvalue("sm_keygroup_set", steamid, "setting_type", "match_name_t")

	es.tell(userid, "#green", "Type the name of the terrorist team in the chat or type !cancel to cancel.")

def name_ct(userid, choice, popupid):
	steamid = es.getplayersteamid(userid)
	exists = es.exists("key", "sm_keygroup_set", steamid)
	if exists == 0:
		es.keycreate("sm_keygroup_set", steamid)

	es.keysetvalue("sm_keygroup_set", steamid, "setting_type", "match_name_ct")

	es.tell(userid, "#green", "Type the name of the counter-terrorist team in the chat or type !cancel to cancel.")

def short_name_t(userid, choice, popupid):
	steamid = es.getplayersteamid(userid)
	exists = es.exists("key", "sm_keygroup_set", steamid)
	if exists == 0:
		es.keycreate("sm_keygroup_set", steamid)

	es.keysetvalue("sm_keygroup_set", steamid, "setting_type", "match_name_t_abbr")

	es.tell(userid, "#green", "Type the short name of the terrorist team in the chat or type !cancel to cancel.")

def short_name_ct(userid, choice, popupid):
	steamid = es.getplayersteamid(userid)
	exists = es.exists("key", "sm_keygroup_set", steamid)
	if exists == 0:
		es.keycreate("sm_keygroup_set", steamid)

	es.keysetvalue("sm_keygroup_set", steamid, "setting_type", "match_name_ct_abbr")

	es.tell(userid, "#green", "Type the short name of the counter-terrorist team in the chat or type !cancel to cancel.")

def player_say(event_var):
	steamid = es.getplayersteamid(event_var["userid"])

	exists = es.exists("key", "sm_keygroup_set", steamid)
	if exists == 1:
		type = es.keygetvalue("sm_keygroup_set", steamid, "setting_type")
		if type == "match_name_t":
			if event_var["text"] != "!cancel":
				es.set("sm_match_name_t", event_var["text"])

				line = "->1. %s: %s" % (text("name_t"), event_var["text"])
				popup.modline(3, line)

				tokens = {}
				tokens['team'] = event_var["text"]
				line = "->1. %s" % (text_score("add", tokens))
				popuplib.find("sm_popup_admin_match_score").modline(3, line)

				tokens = {}
				tokens['team'] = event_var["text"]
				line = "->2. %s" % (text_score("remove", tokens))
				popuplib.find("sm_popup_admin_match_score").modline(4, line)

				name = es.getplayername(event_var["userid"])
				message = "%s has set the name of the terrorist team to %s." % (name, event_var["text"])
				es.msg("#green", message)

				clear_key(event_var["userid"], steamid)
			else:
				clear_key(event_var["userid"], steamid)
		elif type == "match_name_ct":
			if event_var["text"] != "!cancel":
				es.set("sm_match_name_ct", event_var["text"])

				line = "->2. %s: %s" % (text("name_ct"), event_var["text"])
				popup.modline(4, line)

				tokens = {}
				tokens['team'] = event_var["text"]
				line = "->3. %s" % (text_score("add", tokens))
				popuplib.find("sm_popup_admin_match_score").modline(5, line)

				tokens = {}
				tokens['team'] = event_var["text"]
				line = "->4. %s" % (text_score("remove", tokens))
				popuplib.find("sm_popup_admin_match_score").modline(6, line)

				name = es.getplayername(event_var["userid"])
				message = "%s has set the name of the counter-terrorist team to %s." % (name, event_var["text"])
				es.msg("#green", message)

				clear_key(event_var["userid"], steamid)
			else:
				clear_key(event_var["userid"], steamid)
		elif type == "match_name_t_abbr":
			if event_var["text"] != "!cancel":
				length = len(event_var["text"])
				if length < 6:
					es.set("sm_match_name_t_abbr", event_var["text"])

					line = "->3. %s: %s" % (text("short_name_t"), event_var["text"])
					popup.modline(5, line)

					name = es.getplayername(event_var["userid"])
					message = "%s has set the short name of the terrorist team to %s." % (name, event_var["text"])
					es.msg("#green", message)

					clear_key(event_var["userid"], steamid)
				else:
					es.tell(event_var["userid"], "#green", "Short name can not be longer then 5 characters.")
			else:
				clear_key(event_var["userid"], steamid)
		elif type == "match_name_ct_abbr":
			if event_var["text"] != "!cancel":
				length = len(event_var["text"])
				if length < 6:
					es.set("sm_match_name_ct_abbr", event_var["text"])

					line = "->4. %s: %s" % (text("short_name_ct"), event_var["text"])
					popup.modline(6, line)

					name = es.getplayername(event_var["userid"])
					message = "%s has set the short name of the counter-terrorist team to %s." % (name, event_var["text"])
					es.msg("#green", message)

					clear_key(event_var["userid"], steamid)
				else:
					es.tell(event_var["userid"], "#green", "Short name can not be longer then 5 characters.")
			else:
				clear_key(event_var["userid"], steamid)

def clear_key(userid, steamid):
	es.keydelete("sm_keygroup_set", steamid)
	popuplib.send("sm_popup_admin_match_names", userid)

def reset_names(userid, choice, popupid):
	name = es.ServerVar("sm_match_default_name_t")
	line = "->1. %s: %s" % (text("name_t"), name)
	popup.modline(3, line)
	es.set("sm_match_name_t", name)

	tokens = {}
	tokens['team'] = name
	line = "->1. %s" % (text_score("add", tokens))
	popuplib.find("sm_popup_admin_match_score").modline(3, line)

	tokens = {}
	tokens['team'] = name
	line = "->2. %s" % (text_score("remove", tokens))
	popuplib.find("sm_popup_admin_match_score").modline(4, line)

	name = es.ServerVar("sm_match_default_name_ct")
	line = "->2. %s: %s" % (text("name_ct"), name)
	popup.modline(4, line)
	es.set("sm_match_name_ct", name)

	tokens = {}
	tokens['team'] = name
	line = "->3. %s" % (text_score("add", tokens))
	popuplib.find("sm_popup_admin_match_score").modline(5, line)

	tokens = {}
	tokens['team'] = name
	line = "->4. %s" % (text_score("remove", tokens))
	popuplib.find("sm_popup_admin_match_score").modline(6, line)

	name = es.ServerVar("sm_match_default_name_t_abbr")
	line = "->3. %s: %s" % (text("short_name_t"), name)
	popup.modline(5, line)
	es.set("sm_match_name_t_abbr", name)

	name = es.ServerVar("sm_match_default_name_ct_abbr")
	line = "->4. %s: %s" % (text("short_name_ct"), name)
	popup.modline(6, line)
	es.set("sm_match_name_ct_abbr", name)

	name = es.getplayername(userid)
	message = "%s has reset the names." % (name)
	es.msg("#green", message)

	popuplib.send("sm_popup_admin_match_names", userid)

def delete_popup():
	if popuplib.exists("sm_popup_admin_match_names"):
		popuplib.delete("sm_popup_admin_match_names")

def unload():
	delete_popup()