import es
import langlib
import popuplib

popup = popuplib.create("sm_popup_admin_settings_match_main")
text = langlib.Strings("cstrike/addons/eventscripts/soccer_mod_2010/language/settings/popup_admin_settings_match_main.ini")

def load():
	load_settings()
	create_popup()

def load_settings():
	value = int(es.keygetvalue("soccer_mod_settings", "match", "public_start_match"))
	es.set("sm_match_say_command_start_match_on", value)

	value = int(es.keygetvalue("soccer_mod_settings", "match", "public_pause_match"))
	es.set("sm_match_say_command_pause_match_on", value)

	value = int(es.keygetvalue("soccer_mod_settings", "match", "public_stop_match"))
	es.set("sm_match_say_command_stop_match_on", value)

	value = int(es.keygetvalue("soccer_mod_settings", "match", "ready_vote"))
	es.set("sm_match_ready_vote_on", value)

	value = int(es.keygetvalue("soccer_mod_settings", "match", "match_sounds"))
	es.set("sm_match_sounds_on", value)

	value = int(es.keygetvalue("soccer_mod_settings", "match", "score_board"))
	es.set("sm_match_score_board_on", value)

	value = int(es.keygetvalue("soccer_mod_settings", "match", "golden_goal"))
	es.set("sm_match_golden_goal_on", value)

def create_popup():
	line = "SOCCER MOD %s" % (text("title"))
	popup.addline(line)

	popup.addline(" ")

	value = es.ServerVar("sm_match_say_command_start_match_on")
	if value == 1:
		value = text("on")
	else:
		value = text("off")

	line = "->1. %s: %s" % (text("start match"), value)
	popup.addline(line)

	value = es.ServerVar("sm_match_say_command_pause_match_on")
	if value == 1:
		value = text("on")
	else:
		value = text("off")

	line = "->2. %s: %s" % (text("pause match"), value)
	popup.addline(line)

	value = es.ServerVar("sm_match_say_command_stop_match_on")
	if value == 1:
		value = text("on")
	else:
		value = text("off")

	line = "->3. %s: %s" % (text("stop match"), value)
	popup.addline(line)

	value = es.ServerVar("sm_match_ready_vote_on")
	if value == 1:
		value = text("on")
	else:
		value = text("off")

	line = "->4. %s: %s" % (text("ready vote"), value)
	popup.addline(line)

	value = es.ServerVar("sm_match_sounds_on")
	if value == 1:
		value = text("on")
	else:
		value = text("off")

	line = "->5. %s: %s" % (text("sounds"), value)
	popup.addline(line)

	value = es.ServerVar("sm_match_score_board_on")
	if value == 1:
		value = text("on")
	else:
		value = text("off")

	line = "->6. %s: %s" % (text("score board"), value)
	popup.addline(line)

	value = es.ServerVar("sm_match_golden_goal_on")
	if value == 1:
		value = text("on")
	else:
		value = text("off")

	line = "->7. %s: %s" % (text("golden goal"), value)
	popup.addline(line)

	popup.addline(" ")

	line = "->9. %s" % (text("back"))
	popup.addline(line)

	popup.addline(" ")

	line = "->0. %s" % (text("close"))
	popup.addline(line)

	popup.select(1, public_start_match)
	popup.select(2, public_pause_match)
	popup.select(3, public_stop_match)
	popup.select(4, ready_vote)
	popup.select(5, match_sounds)
	popup.select(6, score_board)
	popup.select(7, golden_goal)
	popup.submenu(8, "sm_popup_admin_settings_match_main")
	popup.submenu(9, "sm_popup_admin_settings_match")

def public_start_match(userid, choice, popupid):
	name = es.getplayername(userid)
	value = es.ServerVar("sm_match_say_command_start_match_on")
	if value == 1:
		es.set("sm_match_say_command_start_match_on", 0)
		es.keysetvalue("soccer_mod_settings", "match", "public_start_match", 0)

		line = "->1. %s: %s" % (text("start match"), text("off"))
		popup.modline(3, line)

		message = "%s has turned the public start match command off." % (name)
	else:
		es.set("sm_match_say_command_start_match_on", 1)
		es.keysetvalue("soccer_mod_settings", "match", "public_start_match", 1)

		line = "->1. %s: %s" % (text("start match"), text("on"))
		popup.modline(3, line)

		message = "%s has turned the public start match command on." % (name)

	es.msg("#green", message)

	es.keygroupsave("soccer_mod_settings", "soccer_mod")

	popuplib.send("sm_popup_admin_settings_match_main", userid)

def public_pause_match(userid, choice, popupid):
	name = es.getplayername(userid)
	value = es.ServerVar("sm_match_say_command_pause_match_on")
	if value == 1:
		es.set("sm_match_say_command_pause_match_on", 0)
		es.keysetvalue("soccer_mod_settings", "match", "public_pause_match", 0)

		line = "->2. %s: %s" % (text("pause match"), text("off"))
		popup.modline(4, line)

		message = "%s has turned the public pause match command off." % (name)
	else:
		es.set("sm_match_say_command_pause_match_on", 1)
		es.keysetvalue("soccer_mod_settings", "match", "public_pause_match", 1)

		line = "->2. %s: %s" % (text("pause match"), text("on"))
		popup.modline(4, line)

		message = "%s has turned the public pause match command on." % (name)

	es.msg("#green", message)

	es.keygroupsave("soccer_mod_settings", "soccer_mod")

	popuplib.send("sm_popup_admin_settings_match_main", userid)

def public_stop_match(userid, choice, popupid):
	name = es.getplayername(userid)
	value = es.ServerVar("sm_match_say_command_stop_match_on")
	if value == 1:
		es.set("sm_match_say_command_stop_match_on", 0)
		es.keysetvalue("soccer_mod_settings", "match", "public_stop_match", 0)

		line = "->3. %s: %s" % (text("stop match"), text("off"))
		popup.modline(5, line)

		message = "%s has turned the public stop match command off." % (name)
	else:
		es.set("sm_match_say_command_stop_match_on", 1)
		es.keysetvalue("soccer_mod_settings", "match", "public_stop_match", 1)

		line = "->3. %s: %s" % (text("stop match"), text("on"))
		popup.modline(5, line)

		message = "%s has turned the public stop match command on." % (name)

	es.msg("#green", message)

	es.keygroupsave("soccer_mod_settings", "soccer_mod")

	popuplib.send("sm_popup_admin_settings_match_main", userid)

def ready_vote(userid, choice, popupid):
	name = es.getplayername(userid)
	value = es.ServerVar("sm_match_ready_vote_on")
	if value == 1:
		es.set("sm_match_ready_vote_on", 0)
		es.keysetvalue("soccer_mod_settings", "match", "ready_vote", 0)

		line = "->4. %s: %s" % (text("ready vote"), text("off"))
		popup.modline(6, line)

		message = "%s has turned the ready for match vote off." % (name)
	else:
		es.set("sm_match_ready_vote_on", 1)
		es.keysetvalue("soccer_mod_settings", "match", "ready_vote", 1)

		line = "->4. %s: %s" % (text("ready vote"), text("on"))
		popup.modline(6, line)

		message = "%s has turned the ready for match vote on." % (name)

	es.msg("#green", message)

	es.keygroupsave("soccer_mod_settings", "soccer_mod")

	popuplib.send("sm_popup_admin_settings_match_main", userid)

def match_sounds(userid, choice, popupid):
	name = es.getplayername(userid)
	value = es.ServerVar("sm_match_sounds_on")
	if value == 1:
		es.set("sm_match_sounds_on", 0)
		es.keysetvalue("soccer_mod_settings", "match", "match_sounds", 0)

		line = "->5. %s: %s" % (text("sounds"), text("off"))
		popup.modline(7, line)

		message = "%s has turned the match sounds off." % (name)
	else:
		es.set("sm_match_sounds_on", 1)
		es.keysetvalue("soccer_mod_settings", "match", "match_sounds", 1)

		line = "->5. %s: %s" % (text("sounds"), text("on"))
		popup.modline(7, line)

		message = "%s has turned the match sounds on." % (name)

	es.msg("#green", message)

	es.keygroupsave("soccer_mod_settings", "soccer_mod")

	popuplib.send("sm_popup_admin_settings_match_main", userid)

def score_board(userid, choice, popupid):
	name = es.getplayername(userid)
	value = es.ServerVar("sm_match_score_board_on")
	if value == 1:
		es.set("sm_match_score_board_on", 0)
		es.keysetvalue("soccer_mod_settings", "match", "score_board", 0)

		line = "->6. %s: %s" % (text("score board"), text("off"))
		popup.modline(8, line)

		message = "%s has turned the score board off." % (name)
	else:
		es.set("sm_match_score_board_on", 1)
		es.keysetvalue("soccer_mod_settings", "match", "score_board", 1)

		line = "->6. %s: %s" % (text("score board"), text("on"))
		popup.modline(8, line)

		message = "%s has turned the score board on." % (name)

	es.msg("#green", message)

	es.keygroupsave("soccer_mod_settings", "soccer_mod")

	popuplib.send("sm_popup_admin_settings_match_main", userid)

def golden_goal(userid, choice, popupid):
	name = es.getplayername(userid)
	value = es.ServerVar("sm_match_golden_goal_on")
	if value == 1:
		es.set("sm_match_golden_goal_on", 0)
		es.keysetvalue("soccer_mod_settings", "match", "golden_goal", 0)

		line = "->7. %s: %s" % (text("golden goal"), text("off"))
		popup.modline(9, line)

		message = "%s has turned golden goal off." % (name)
	else:
		es.set("sm_match_golden_goal_on", 1)
		es.keysetvalue("soccer_mod_settings", "match", "golden_goal", 1)

		line = "->7. %s: %s" % (text("golden goal"), text("on"))
		popup.modline(9, line)

		message = "%s has turned golden goal on." % (name)

	es.msg("#green", message)

	es.keygroupsave("soccer_mod_settings", "soccer_mod")

	popuplib.send("sm_popup_admin_settings_match_main", userid)

def delete_popup():
	if popuplib.exists("sm_popup_admin_settings_match_main"):
		popuplib.delete("sm_popup_admin_settings_match_main")

def unload():
	delete_popup()