import es
import langlib
import popuplib

popup = popuplib.create("sm_popup_admin_settings_match_time")
text = langlib.Strings("cstrike/addons/eventscripts/soccer_mod_2010/language/settings/popup_admin_settings_match_time.ini")

def load():
	load_settings()
	create_popup()

def load_settings():
	value = int(es.keygetvalue("soccer_mod_settings", "match", "periods"))
	es.set("sm_match_number_periods", value)

	value = int(es.keygetvalue("soccer_mod_settings", "match", "restart_length"))
	es.set("sm_match_restart_length", value)

	value = int(es.keygetvalue("soccer_mod_settings", "match", "period_length"))
	es.set("sm_match_period_length", value)

	value = int(es.keygetvalue("soccer_mod_settings", "match", "period_break_length"))
	es.set("sm_match_period_break_length", value)

def create_popup():
	line = "SOCCER MOD %s" % (text("title"))
	popup.addline(line)

	popup.addline(" ")

	value = es.ServerVar("sm_match_number_periods")
	line = "->1. %s: %s" % (text("periods"), value)
	popup.addline(line)

	value = es.ServerVar("sm_match_restart_length")
	line = "->2. %s: %s" % (text("restart_length"), value)
	popup.addline(line)

	value = es.ServerVar("sm_match_period_length")
	line = "->3. %s: %s" % (text("period_length"), value)
	popup.addline(line)

	value = es.ServerVar("sm_match_period_break_length")
	line = "->4. %s: %s" % (text("period_break_length"), value)
	popup.addline(line)

	popup.addline(" ")

	line = "->9. %s" % (text("back"))
	popup.addline(line)

	popup.addline(" ")

	line = "->0. %s" % (text("close"))
	popup.addline(line)

	popup.select(1, periods)
	popup.select(2, restart_length)
	popup.select(3, period_length)
	popup.select(4, period_break_length)
	popup.submenu(5, "sm_popup_admin_settings_match_time")
	popup.submenu(6, "sm_popup_admin_settings_match_time")
	popup.submenu(7, "sm_popup_admin_settings_match_time")
	popup.submenu(8, "sm_popup_admin_settings_match_time")
	popup.submenu(9, "sm_popup_admin_settings_match")

def periods(userid, choice, popupid):
	check = es.ServerVar("match")
	if check == 0:
		steamid = es.getplayersteamid(userid)
		exists = es.exists("key", "sm_keygroup_set", steamid)
		if exists == 0:
			es.keycreate("sm_keygroup_set", steamid)

		es.keysetvalue("sm_keygroup_set", steamid, "setting_type", "settings_match_time_periods")

		es.tell(userid, "#green", "Type a value between 1 and 10 in the chat to set the number of periods or type !cancel to cancel.")
	else:
		es.tell(userid, "#green", "You can not change the time settings during a match.")
		popuplib.send("sm_popup_admin_settings_match_time", userid)

def restart_length(userid, choice, popupid):
	check = es.ServerVar("match")
	if check == 0:
		steamid = es.getplayersteamid(userid)
		exists = es.exists("key", "sm_keygroup_set", steamid)
		if exists == 0:
			es.keycreate("sm_keygroup_set", steamid)

		es.keysetvalue("sm_keygroup_set", steamid, "setting_type", "settings_match_time_restart_length")

		es.tell(userid, "#green", "Type a value between 1 and 60 in the chat to set the restart length or type !cancel to cancel.")
	else:
		es.tell(userid, "#green", "You can not change the time settings during a match.")
		popuplib.send("sm_popup_admin_settings_match_time", userid)

def period_length(userid, choice, popupid):
	check = es.ServerVar("match")
	if check == 0:
		steamid = es.getplayersteamid(userid)
		exists = es.exists("key", "sm_keygroup_set", steamid)
		if exists == 0:
			es.keycreate("sm_keygroup_set", steamid)

		es.keysetvalue("sm_keygroup_set", steamid, "setting_type", "settings_match_time_period_length")

		es.tell(userid, "#green", "Type a value between 1 and 10000 in the chat to set the period length or type !cancel to cancel.")
	else:
		es.tell(userid, "#green", "You can not change the time settings during a match.")
		popuplib.send("sm_popup_admin_settings_match_time", userid)

def period_break_length(userid, choice, popupid):
	check = es.ServerVar("match")
	if check == 0:
		steamid = es.getplayersteamid(userid)
		exists = es.exists("key", "sm_keygroup_set", steamid)
		if exists == 0:
			es.keycreate("sm_keygroup_set", steamid)

		es.keysetvalue("sm_keygroup_set", steamid, "setting_type", "settings_match_time_period_break_length")

		es.tell(userid, "#green", "Type a value between 1 and 10000 in the chat to set the period break length or type !cancel to cancel.")
	else:
		es.tell(userid, "#green", "You can not change the time settings during a match.")
		popuplib.send("sm_popup_admin_settings_match_time", userid)

def player_say(event_var):
	steamid = es.getplayersteamid(event_var["userid"])

	exists = es.exists("key", "sm_keygroup_set", steamid)
	if exists == 1:
		type = es.keygetvalue("sm_keygroup_set", steamid, "setting_type")
		if type == "settings_match_time_periods":
			if event_var["text"] != "!cancel":
				error = "Type a value between 1 and 10 in the chat to set the number of periods or type !cancel to cancel."
				try:
					temp_value = float(event_var["text"])
					value = int(round(temp_value, 0))
					if value >= 1:
						if value <= 10:
							es.set("sm_match_number_periods", value)

							line = "->1. %s: %s" % (text("periods"), value)
							popup.modline(3, line)

							es.keysetvalue("soccer_mod_settings", "match", "periods", value)
							es.keygroupsave("soccer_mod_settings", "soccer_mod")

							name = es.getplayername(event_var["userid"])
							message = "%s has set the number of periods to %s." % (name, value)
							es.msg("#green", message)

							clear_key(event_var["userid"], steamid)
						else:
							es.tell(event_var["userid"], "#green", error)
					else:
						es.tell(event_var["userid"], "#green", error)
				except ValueError:
					es.tell(event_var["userid"], "#green", error)
			else:
				clear_key(event_var["userid"], steamid)
		elif type == "settings_match_time_restart_length":
			if event_var["text"] != "!cancel":
				error = "Type a value between 1 and 60 in the chat to set the restart length or type !cancel to cancel."
				try:
					temp_value = float(event_var["text"])
					value = int(round(temp_value, 0))
					if value >= 1:
						if value <= 60:
							es.set("sm_match_restart_length", value)

							line = "->2. %s: %s" % (text("restart_length"), value)
							popup.modline(4, line)

							es.keysetvalue("soccer_mod_settings", "match", "restart_length", value)
							es.keygroupsave("soccer_mod_settings", "soccer_mod")

							name = es.getplayername(event_var["userid"])
							message = "%s has set the restart length to %s." % (name, value)
							es.msg("#green", message)

							clear_key(event_var["userid"], steamid)
						else:
							es.tell(event_var["userid"], "#green", error)
					else:
						es.tell(event_var["userid"], "#green", error)
				except ValueError:
					es.tell(event_var["userid"], "#green", error)
			else:
				clear_key(event_var["userid"], steamid)
		elif type == "settings_match_time_period_length":
			if event_var["text"] != "!cancel":
				error = "Type a value between 1 and 10000 in the chat to set the period length or type !cancel to cancel."
				try:
					temp_value = float(event_var["text"])
					value = int(round(temp_value, 0))
					if value >= 1:
						if value <= 10000:
							es.set("sm_match_period_length", value)

							line = "->3. %s: %s" % (text("period_length"), value)
							popup.modline(5, line)

							es.keysetvalue("soccer_mod_settings", "match", "period_length", value)
							es.keygroupsave("soccer_mod_settings", "soccer_mod")

							name = es.getplayername(event_var["userid"])
							message = "%s has set the period length to %s." % (name, value)
							es.msg("#green", message)

							clear_key(event_var["userid"], steamid)
						else:
							es.tell(event_var["userid"], "#green", error)
					else:
						es.tell(event_var["userid"], "#green", error)
				except ValueError:
					es.tell(event_var["userid"], "#green", error)
			else:
				clear_key(event_var["userid"], steamid)
		elif type == "settings_match_time_period_break_length":
			if event_var["text"] != "!cancel":
				error = "Type a value between 1 and 10000 in the chat to set the period break length or type !cancel to cancel."
				try:
					temp_value = float(event_var["text"])
					value = int(round(temp_value, 0))
					if value >= 1:
						if value <= 10000:
							es.set("sm_match_period_break_length", value)

							line = "->4. %s: %s" % (text("period_break_length"), value)
							popup.modline(6, line)

							es.keysetvalue("soccer_mod_settings", "match", "period_break_length", value)
							es.keygroupsave("soccer_mod_settings", "soccer_mod")

							name = es.getplayername(event_var["userid"])
							message = "%s has set the period break length to %s." % (name, value)
							es.msg("#green", message)

							clear_key(event_var["userid"], steamid)
						else:
							es.tell(event_var["userid"], "#green", error)
					else:
						es.tell(event_var["userid"], "#green", error)
				except ValueError:
					es.tell(event_var["userid"], "#green", error)
			else:
				clear_key(event_var["userid"], steamid)

def clear_key(userid, steamid):
	es.keydelete("sm_keygroup_set", steamid)
	popuplib.send("sm_popup_admin_settings_match_time", userid)

def delete_popup():
	if popuplib.exists("sm_popup_admin_settings_match_time"):
		popuplib.delete("sm_popup_admin_settings_match_time")

def unload():
	delete_popup()