import es
import gamethread
import langlib
import playerlib
import popuplib

def load():
	create_popup()
	es.keygroupcreate("sm_keygroup_shout")

def create_popup():
	text = langlib.Strings("cstrike/addons/eventscripts/soccer_mod_2010/language/shout/popup_shout.ini")

	popup = popuplib.create("sm_popup_shout")

	popup.addline(text("title"))

	line = "1. %s" % (text("foul"))
	popup.addline(line)

	line = "2. %s" % (text("goal"))
	popup.addline(line)

	line = "3. %s" % (text("ole"))
	popup.addline(line)

	line = "4. %s" % (text("pass"))
	popup.addline(line)

	line = "5. %s" % (text("save"))
	popup.addline(line)

	line = "6. %s" % (text("shot"))
	popup.addline(line)

	line = "0. %s" % (text("close"))
	popup.addline(line)

	popup.select(1, shout)
	popup.select(2, shout)
	popup.select(3, shout)
	popup.select(4, shout)
	popup.select(5, shout)
	popup.select(6, shout)
	popup.submenu(7, "sm_popup_shout")
	popup.submenu(8, "sm_popup_shout")
	popup.submenu(9, "sm_popup_shout")

def cmd_shout():
	userid = es.getcmduserid()

	enabled = es.ServerVar("soccer_mod_allowed")
	if enabled == 1:
		myPlayer = playerlib.getPlayer(userid)
		if myPlayer.isdead == 0:
			popuplib.send("sm_popup_shout", userid)
		else:
			es.tell(userid, "#green", "You can not use the shout commands when dead.")
	else:
		es.tell(userid, "#green", "Soccer Mod is not allowed on this map.")

def shout(userid, choice, popupid):
	myPlayer = playerlib.getPlayer(userid)
	if myPlayer.isdead == 0:
		exists = es.exists("key", "sm_keygroup_shout", userid)
		if exists == 0:
			es.keycreate("sm_keygroup_shout", userid)

			if choice == 1:
				sound = es.ServerVar("sm_shout_sound_foul")
				es.emitsound("player", userid, sound, "1.0", "1.0")

			elif choice == 2:
				sound = es.ServerVar("sm_shout_sound_goal")
				es.emitsound("player", userid, sound, "1.0", "1.0")

			elif choice == 3:
				sound = es.ServerVar("sm_shout_sound_ole")
				es.emitsound("player", userid, sound, "1.0", "1.0")

			elif choice == 4:
				sound = es.ServerVar("sm_shout_sound_pass")
				es.emitsound("player", userid, sound, "1.0", "1.0")

			elif choice == 5:
				sound = es.ServerVar("sm_shout_sound_save")
				es.emitsound("player", userid, sound, "1.0", "1.0")

			elif choice == 6:
				sound = es.ServerVar("sm_shout_sound_shot")
				es.emitsound("player", userid, sound, "1.0", "1.0")

			delay = es.ServerVar("sm_shout_delay")
			gamethread.delayed(delay, clear_key, (userid))
	else:
		es.tell(userid, "#green", "You can not use the shout commands when dead.")

def clear_key(userid):
	es.keydelete("sm_keygroup_shout", userid)
		
def unload():
	es.keygroupdelete("sm_keygroup_shout")
	popuplib.delete("sm_popup_shout")