import es
import gamethread
import langlib
import playerlib

text = langlib.Strings("cstrike/addons/eventscripts/soccer_mod_2010/language/sprint/sprint_messages.ini")

def load():
	es.keygroupcreate("sm_keygroup_sprint")

def cmd_sprint():
	userid = es.getcmduserid()

	enabled = es.ServerVar("soccer_mod_allowed")
	if enabled == 1:
		exists = es.exists("key", "sm_keygroup_sprint", userid)
		if exists == 0:
			es.keycreate("sm_keygroup_sprint", userid)

			player = playerlib.getPlayer(userid)

			speed = es.ServerVar("sm_sprint_speed")
			player.setSpeed(speed)

			es.tell(userid, "#green", text("use"))

			length = es.ServerVar("sm_sprint_length")
			gamethread.delayed(length, stop, (userid))

			reset_length = es.ServerVar("sm_sprint_reset")
			gamethread.delayed(reset_length, reset, (userid))
	else:
		es.tell(userid, "#green", text("not_allowed"))

def stop(userid):
	player = playerlib.getPlayer(userid)
	player.setSpeed(1)
	es.tell(userid, "#green", text("end"))

def reset(userid):
	es.keydelete("sm_keygroup_sprint", userid)
	es.tell(userid, "#green", text("reset"))

def unload():
	es.keygroupdelete("sm_keygroup_sprint")