import es
import gamethread
import langlib
import playerlib
import popuplib
import random
import repeat
import vecmath

popup = popuplib.create("sm_popup_admin_training_cannon")
text = langlib.Strings("cstrike/addons/eventscripts/soccer_mod_2010/language/training/popup_admin_training_cannon.ini")

def load():
	load_variables()
	create_popup()
	sm_training_cannon = repeat.create("cannon", shoot, ())

def load_variables():
	es.set("sm_training_cannon_on", 0)
	es.set("sm_training_randomness", 1)
	es.set("sm_training_fire_rate", 2.5)
	es.set("sm_training_height", 1)
	es.set("sm_training_power", 10000)

def round_start(event_var):
	enabled = es.ServerVar("soccer_mod_allowed")
	if enabled == 1:
		entity = es.getentityindex("func_physbox")
		es.set("sm_training_ballid", entity)

def player_disconnect(event_var):
	enabled = es.ServerVar("soccer_mod_allowed")
	if enabled == 1:
		number = 0
		players = es.getUseridList()
		for player in players:
			number += 1

		if number < 1:
			sm_training_cannon = repeat.find("cannon")

			check = sm_training_cannon.status()
			if check > 1:
				sm_training_cannon.stop()

def create_popup():
	line = "SOCCER MOD %s" % (text("title"))
	popup.addline(line)

	popup.addline(" ")

	line = "->1. %s" % (text("position"))
	popup.addline(line)

	line = "->2. %s" % (text("aim"))
	popup.addline(line)

	line = "->3. %s" % (text("on"))
	popup.addline(line)

	line = "->4. %s" % (text("off"))
	popup.addline(line)

	value = es.ServerVar("sm_training_randomness")
	line = "->5. %s: %s" % (text("randomness"), value)
	popup.addline(line)

	value = es.ServerVar("sm_training_fire_rate")
	line = "->6. %s: %s" % (text("fire_rate"), value)
	popup.addline(line)

	value = es.ServerVar("sm_training_height")
	line = "->7. %s: %s" % (text("height"), value)
	popup.addline(line)

	value = es.ServerVar("sm_training_power")
	line = "->8. %s: %s" % (text("power"), value)
	popup.addline(line)

	popup.addline(" ")

	line = "->9. %s" % (text("back"))
	popup.addline(line)

	popup.addline(" ")

	line = "->0. %s" % (text("close"))
	popup.addline(line)

	popup.select(1, position)
	popup.select(2, aim_position)
	popup.select(3, cannon_on)
	popup.select(4, cannon_off)
	popup.select(5, set_randomness)
	popup.select(6, set_fire_rate)
	popup.select(7, set_height)
	popup.select(8, set_power)
	popup.submenu(9, "sm_popup_admin_training")

def position(userid, choice, popupid):
	check = es.ServerVar("match")
	if check == 0:
		player = playerlib.getPlayer(userid)
		view = player.getViewCoord()

		coordinates = view.split(",")
		es.set("cannon_x", float(coordinates[0]))
		es.set("cannon_y", float(coordinates[1]))
		es.set("cannon_z", (float(coordinates[2]) + 15))

		show_position(float(coordinates[0]), float(coordinates[1]), float(coordinates[2]))

		name = es.getplayername(userid)
		message = "%s has set the cannon position." % (name)
		es.msg("#green", message)
	else:
		es.tell(userid, "#green", "You can not set the cannon position during a match.")

	popuplib.send("sm_popup_admin_training_cannon", userid)

def aim_position(userid, choice, popupid):
	check = es.ServerVar("match")
	if check == 0:
		player = playerlib.getPlayer(userid)
		view = player.getViewCoord()

		coordinates = view.split(",")
		es.set("cannon_aim_x", float(coordinates[0]))
		es.set("cannon_aim_y", float(coordinates[1]))
		es.set("cannon_aim_z", float(coordinates[2]))

		show_position(float(coordinates[0]), float(coordinates[1]), float(coordinates[2]))

		name = es.getplayername(userid)
		message = "%s has set the cannon aim position." % (name)
		es.msg("#green", message)
	else:
		es.tell(userid, "#green", "You can not set the cannon position during a match.")

	popuplib.send("sm_popup_admin_training_cannon", userid)

def show_position(x, y, z):
	model = es.precachemodel("sprites/crystal_beam1.vmt")

	pos1 = "%s,%s,%s" % ((x - 25), y, z)
	pos2 = "%s,%s,%s" % ((x + 25), y, z)

	cmd = "es_effect beam %s %s %s %s 0 0 5 5 5 0 1 255 0 0 255 5" % (pos1, pos2, model, model)
	es.server.cmd(cmd)

	pos1 = "%s,%s,%s" % (x, (y - 25), z)
	pos2 = "%s,%s,%s" % (x, (y + 25), z)

	cmd = "es_effect beam %s %s %s %s 0 0 5 5 5 0 1 255 0 0 255 5" % (pos1, pos2, model, model)
	es.server.cmd(cmd)

	pos1 = "%s,%s,%s" % (x, y, (z - 25))
	pos2 = "%s,%s,%s" % (x, y, (z + 25))

	cmd = "es_effect beam %s %s %s %s 0 0 5 5 5 0 1 255 0 0 255 5" % (pos1, pos2, model, model)
	es.server.cmd(cmd)

def cannon_on(userid, choice, popupid):
	check = es.ServerVar("match")
	if check == 0:
		check = es.ServerVar("sm_training_ballid")
		if check > 0:
			sm_training_cannon = repeat.find("cannon")

			check = sm_training_cannon.status()
			if check == 1:
				delay = float(es.ServerVar("sm_training_fire_rate"))
				sm_training_cannon.start(delay, 0)

				es.set("sm_training_first_shot", 1)
				es.set("sm_training_cannon_on", 1)

				shoot()

				name = es.getplayername(userid)
				message = "%s has turned the cannon on." % (name)
				es.msg("#green", message)
			else:
				es.tell(userid, "#green", "The cannon is already on.")
		else:
			es.tell(userid, "#green", "No ball found.")
	else:
		es.tell(userid, "#green", "You can not set the cannon position during a match.")

	popuplib.send("sm_popup_admin_training_cannon", userid)

def cannon_off(userid, choice, popupid):
	sm_training_cannon = repeat.find("cannon")

	check = sm_training_cannon.status()
	if check > 1:
		sm_training_cannon.stop()

		es.set("sm_training_cannon_on", 0)

		name = es.getplayername(userid)
		message = "%s has turned the cannon off." % (name)
		es.msg("#green", message)
	else:
		es.tell(userid, "#green", "The cannon is already off.")

	popuplib.send("sm_popup_admin_training_cannon", userid)

def shoot():
	ballid = es.ServerVar("sm_training_ballid")
	x = es.ServerVar("cannon_x")
	y = es.ServerVar("cannon_y")
	z = es.ServerVar("cannon_z")
	value = es.ServerVar("sm_training_height")
	height = int(value)
	z += height

	players = es.getUseridList()
	length = len(players)
	if length > 0:
		length -= 1
		value = random.randint(0, length)
		userid = players[value]

		cmd = 'es_xfire %s func_physbox wake' % (userid)
		es.server.queuecmd(cmd)

	cmd = "es_xphysics active teleport %s %s,%s,%s" % (ballid, x, y, z)
	es.server.cmd(cmd)
	gamethread.delayed(0.1, push)

	check = es.ServerVar("sm_training_first_shot")
	if check == 1:
		es.set("sm_training_first_shot", 0)

		sm_training_cannon = repeat.find("cannon")

		check = sm_training_cannon.status()
		if check == 1:
			delay = float(es.ServerVar("sm_training_fire_rate"))
			sm_training_cannon.start(delay, 0)

def push():
	ballid = es.ServerVar("sm_training_ballid")

	x = es.ServerVar("cannon_aim_x")
	y = es.ServerVar("cannon_aim_y")
	z = es.ServerVar("cannon_aim_z")
	randomness = int(es.ServerVar("sm_training_randomness"))
	if randomness > 0:
		x_min = x
		x_min -= randomness

		x_max = x
		x_max += randomness

		x = random.uniform(x_min, x_max)

		y_min = y
		y_min -= randomness

		y_max = y
		y_max += randomness

		y = random.uniform(y_min, y_max)

		z_min = z
		z_min -= randomness

		z_max = z
		z_max += randomness

		z = random.uniform(z_min, z_max)

	vector1 = vecmath.vector([x, y, z])

	x = es.ServerVar("cannon_x")
	y = es.ServerVar("cannon_y")
	z = es.ServerVar("cannon_z")
	vector2 = vecmath.vector([x, y, z])

	power = float(es.ServerVar("sm_training_power"))
	push_vector = (vector1 - vector2) * power
	es.set("sm_training_cannon_aim", push_vector)

	vector = es.ServerVar("sm_training_cannon_aim")
	cmd = "es_xphysics active setvelocity %s %s" % (ballid, vector)
	es.server.cmd(cmd)

def set_randomness(userid, choice, popupid):
	check = es.ServerVar("match")
	if check == 0:
		steamid = es.getplayersteamid(userid)
		exists = es.exists("key", "sm_keygroup_set", steamid)
		if exists == 0:
			es.keycreate("sm_keygroup_set", steamid)

		es.keysetvalue("sm_keygroup_set", steamid, "setting_type", "training_randomness")

		es.tell(userid, "#green", "Type a value between 1 and 500 in the chat to set the cannon randomness or type !cancel to cancel.")
	else:
		es.tell(userid, "#green", "You can not change the ball cannon settings during a match.")
		popuplib.send("sm_popup_admin_training_cannon", userid)

def set_fire_rate(userid, choice, popupid):
	check = es.ServerVar("match")
	if check == 0:
		steamid = es.getplayersteamid(userid)
		exists = es.exists("key", "sm_keygroup_set", steamid)
		if exists == 0:
			es.keycreate("sm_keygroup_set", steamid)

		es.keysetvalue("sm_keygroup_set", steamid, "setting_type", "training_fire_rate")

		es.tell(userid, "#green", "Type a value between 0.5 and 10 in the chat to set the cannon fire rate or type !cancel to cancel.")
	else:
		es.tell(userid, "#green", "You can not change the ball cannon settings during a match.")
		popuplib.send("sm_popup_admin_training_cannon", userid)

def set_height(userid, choice, popupid):
	check = es.ServerVar("match")
	if check == 0:
		steamid = es.getplayersteamid(userid)
		exists = es.exists("key", "sm_keygroup_set", steamid)
		if exists == 0:
			es.keycreate("sm_keygroup_set", steamid)

		es.keysetvalue("sm_keygroup_set", steamid, "setting_type", "training_height")

		es.tell(userid, "#green", "Type a value between 1 and 500 in the chat to set the cannon height or type !cancel to cancel.")
	else:
		es.tell(userid, "#green", "You can not change the ball cannon settings during a match.")
		popuplib.send("sm_popup_admin_training_cannon", userid)

def set_power(userid, choice, popupid):
	check = es.ServerVar("match")
	if check == 0:
		steamid = es.getplayersteamid(userid)
		exists = es.exists("key", "sm_keygroup_set", steamid)
		if exists == 0:
			es.keycreate("sm_keygroup_set", steamid)

		es.keysetvalue("sm_keygroup_set", steamid, "setting_type", "training_power")

		es.tell(userid, "#green", "Type a value between 0.001 and 10000 in the chat to set the cannon power or type !cancel to cancel.")
	else:
		es.tell(userid, "#green", "You can not change the ball cannon settings during a match.")
		popuplib.send("sm_popup_admin_training_cannon", userid)

def player_say(event_var):
	steamid = es.getplayersteamid(event_var["userid"])

	exists = es.exists("key", "sm_keygroup_set", steamid)
	if exists == 1:
		type = es.keygetvalue("sm_keygroup_set", steamid, "setting_type")
		if type == "training_randomness":
			if event_var["text"] != "!cancel":
				error = "Type a value between 1 and 500 in the chat to set the cannon randomness or type !cancel to cancel."
				try:
					temp_value = float(event_var["text"])
					value = int(round(temp_value, 0))
					if value >= 1:
						if value <= 500:
							es.set("sm_training_randomness", value)

							line = "->5. %s: %s" % (text("randomness"), value)
							popup.modline(7, line)

							name = es.getplayername(event_var["userid"])
							message = "%s has set the cannon randomness to %s." % (name, value)
							es.msg("#green", message)

							es.keydelete("sm_keygroup_set", steamid)
							popuplib.send("sm_popup_admin_training_cannon", event_var["userid"])
						else:
							es.tell(event_var["userid"], "#green", error)
					else:
						es.tell(event_var["userid"], "#green", error)
				except ValueError:
					es.tell(event_var["userid"], "#green", error)
			else:
				es.keydelete("sm_keygroup_set", steamid)
				popuplib.send("sm_popup_admin_training_cannon", event_var["userid"])
		elif type == "training_fire_rate":
			if event_var["text"] != "!cancel":
				error = "Type a value between 0.5 and 10 in the chat to set the cannon fire rate or type !cancel to cancel."
				try:
					temp_value = float(event_var["text"])
					value = round(temp_value, 1)
					if value >= 0.5:
						if value <= 10:
							es.set("sm_training_fire_rate", value)

							line = "->6. %s: %s" % (text("fire_rate"), value)
							popup.modline(8, line)

							sm_training_cannon = repeat.find("cannon")

							check = sm_training_cannon.status()
							if check > 1:
								sm_training_cannon.stop()
								es.set("sm_training_first_shot", 1)
								shoot()

							name = es.getplayername(event_var["userid"])
							message = "%s has set the cannon fire rate to %s." % (name, value)
							es.msg("#green", message)

							es.keydelete("sm_keygroup_set", steamid)
							popuplib.send("sm_popup_admin_training_cannon", event_var["userid"])
						else:
							es.tell(event_var["userid"], "#green", error)
					else:
						es.tell(event_var["userid"], "#green", error)
				except ValueError:
					es.tell(event_var["userid"], "#green", error)
			else:
				es.keydelete("sm_keygroup_set", steamid)
				popuplib.send("sm_popup_admin_training_cannon", event_var["userid"])
		elif type == "training_height":
			if event_var["text"] != "!cancel":
				error = "Type a value between 1 and 500 in the chat to set the cannon height or type !cancel to cancel."
				try:
					temp_value = float(event_var["text"])
					value = int(round(temp_value, 0))
					if value >= 1:
						if value <= 500:
							es.set("sm_training_height", value)

							line = "->7. %s: %s" % (text("height"), value)
							popup.modline(9, line)

							name = es.getplayername(event_var["userid"])
							message = "%s has set the cannon height to %s." % (name, value)
							es.msg("#green", message)

							es.keydelete("sm_keygroup_set", steamid)
							popuplib.send("sm_popup_admin_training_cannon", event_var["userid"])
						else:
							es.tell(event_var["userid"], "#green", error)
					else:
						es.tell(event_var["userid"], "#green", error)
				except ValueError:
					es.tell(event_var["userid"], "#green", error)
			else:
				es.keydelete("sm_keygroup_set", steamid)
				popuplib.send("sm_popup_admin_training_cannon", event_var["userid"])
		elif type == "training_power":
			if event_var["text"] != "!cancel":
				error = "Type a value between 0.001 and 10000 in the chat to set the cannon power or type !cancel to cancel."
				try:
					temp_value = float(event_var["text"])
					value = round(temp_value, 3)
					if value >= 0.001:
						if value <= 10000:
							es.set("sm_training_power", value)

							line = "->8. %s: %s" % (text("power"), value)
							popup.modline(10, line)

							name = es.getplayername(event_var["userid"])
							message = "%s has set the cannon power to %s." % (name, value)
							es.msg("#green", message)

							es.keydelete("sm_keygroup_set", steamid)
							popuplib.send("sm_popup_admin_training_cannon", event_var["userid"])
						else:
							es.tell(event_var["userid"], "#green", error)
					else:
						es.tell(event_var["userid"], "#green", error)
				except ValueError:
					es.tell(event_var["userid"], "#green", error)
			else:
				es.keydelete("sm_keygroup_set", steamid)
				popuplib.send("sm_popup_admin_training_cannon", event_var["userid"])

def delete_popup():
	if popuplib.exists("sm_popup_admin_training_cannon"):
		popuplib.delete("sm_popup_admin_training_cannon")

def unload():
	repeat.delete("cannon")

	delete_popup()