import es
import gamethread
import langlib
import playerlib
import popuplib

popup = popuplib.create("sm_popup_vote")

def load():
	create_popup()

def es_map_start(event_var):
	delete_keygroup()

def create_popup():
	text = langlib.Strings("cstrike/addons/eventscripts/soccer_mod_2010/language/vote/popup_vote.ini")

	line = "SOCCER MOD %s" % (text("title"))
	popup.addline(line)

	popup.addline(" ")
	popup.addline("Question?")
	popup.addline(" ")

	line = "->1. %s" % (text("yes"))
	popup.addline(line)

	line = "->2. %s" % (text("no"))
	popup.addline(line)

	popup.addline(" ")

	line = "->0. %s" % (text("close"))
	popup.addline(line)

	popup.select(1, choice)
	popup.select(2, choice)
	popup.submenu(3, "sm_popup_vote")
	popup.submenu(4, "sm_popup_vote")
	popup.submenu(5, "sm_popup_vote")
	popup.submenu(6, "sm_popup_vote")
	popup.submenu(7, "sm_popup_vote")
	popup.submenu(8, "sm_popup_vote")
	popup.submenu(9, "sm_popup_vote")
	
def cmd_vote():
	userid = es.getcmduserid()
	enabled = es.ServerVar("soccer_mod_allowed")
	if enabled == 1:
		exists = es.exists("keygroup", "sm_keygroup_vote")
		if exists == 1:
			steamid = es.getplayersteamid(userid)

			exists = es.exists("key", "sm_keygroup_vote", steamid)
			if exists == 0:
				es.tell(userid, "#green", "You can not vote.")
			else:
				value = int(es.keygetvalue("sm_keygroup_vote", steamid, "voted"))
				if value == 0:
					popuplib.send("sm_popup_vote", userid)
				else:
					es.tell(userid, "#green", "You already voted.")
		else:
			es.tell(userid, "#green", "No vote active.")
	else:
		es.tell(userid, "#green", "Soccer Mod is not allowed on this map.")

def start():
	es.set("sm_vote_number", 0)
	es.set("sm_vote_yes", 0)
	es.set("sm_vote_no", 0)

	es.keygroupcreate("sm_keygroup_vote")

	time = es.ServerVar("sm_vote_length")

	value = es.ServerVar("sm_vote_question")
	popup.modline(3, value)

	source_tv = es.ServerVar("tv_name")

	type = es.ServerVar("sm_vote_all")
	if type == 1:
		myPlayerList = playerlib.getPlayerList("#all")
		number = 0
		for ply in myPlayerList:
			if ply.name != source_tv:
				es.keycreate("sm_keygroup_vote", ply.steamid)
				es.keysetvalue("sm_keygroup_vote", ply.steamid, "voted", 0)
				popuplib.send("sm_popup_vote", ply.userid)
				number += 1

		es.set("sm_vote_players", number)
	else:
		number = 0
		myPlayerList = playerlib.getPlayerList("#t")
		for ply in myPlayerList:
			es.keycreate("sm_keygroup_vote", ply.steamid)
			es.keysetvalue("sm_keygroup_vote", ply.steamid, "voted", 0)
			popuplib.send("sm_popup_vote", ply.userid)
			number += 1

		myPlayerList = playerlib.getPlayerList("#ct")
		for ply in myPlayerList:
			es.keycreate("sm_keygroup_vote", ply.steamid)
			es.keysetvalue("sm_keygroup_vote", ply.steamid, "voted", 0)
			popuplib.send("sm_popup_vote", ply.userid)
			number += 1

		es.set("sm_vote_players", number)

	sounds = es.ServerVar("sm_vote_sounds_on")
	if sounds == 1:
		sound = es.ServerVar("sm_vote_sound_start")
		es.cexec_all("playgamesound", sound)

	value = es.ServerVar("sm_cmd_vote")
	message = "Type %s to open the vote menu." % (value)
	es.msg("#green", message)

	vote_time(time)

def vote_time(time):
	exists = es.exists("keygroup", "sm_keygroup_vote")
	if exists == 1:
		minutes = int(time / 60)
		seconds = time - (minutes * 60)
		es.set("sm_vote_minutes", minutes)
		es.set("sm_vote_seconds", seconds)

		show_vote_time()

		if time > 0:
			gamethread.delayed(1, vote_time, (time - 1))
		else:
			end_vote()

def show_vote_time():
	vote_yes = es.ServerVar("sm_vote_yes")
	vote_no = es.ServerVar("sm_vote_no")
	players = es.ServerVar("sm_vote_players")
	minutes = es.ServerVar("sm_vote_minutes")
	seconds = es.ServerVar("sm_vote_seconds")

	percentage = int(round((float(vote_yes) / float(players)), 0)) * 100
	es.set("sm_vote_yes_percentage", percentage)

	number = es.ServerVar("sm_vote_number")
	if seconds < 10:
		message = "%s:0%s | Votes: %s/%s - Yes: %s - No: %s" % (minutes, seconds, number, players, vote_yes, vote_no)
	else:
		message = "%s:%s | Votes: %s/%s - Yes: %s - No: %s" % (minutes, seconds, number, players, vote_yes, vote_no)

	myPlayerList = playerlib.getPlayerList("#human")
	for ply in myPlayerList:
		cmd = 'usermsg hudhint %s "%s"' % (ply.userid, message)
		es.server.queuecmd(cmd)

def choice(userid, choice, popupid):
	exists = es.exists("keygroup", "sm_keygroup_vote")
	if exists == 1:
		steamid = es.getplayersteamid(userid)

		exists = es.exists("key", "sm_keygroup_vote", steamid)
		if exists == 1:
			value = int(es.keygetvalue("sm_keygroup_vote", steamid, "voted"))
			if value == 0:
				es.keysetvalue("sm_keygroup_vote", steamid, "voted", 1)

				number = es.ServerVar("sm_vote_number")
				number += 1
				es.set("sm_vote_number", number)

				name = es.getplayername(userid)

				if choice == 1:
					value = es.ServerVar("sm_vote_yes")
					value += 1
					es.set("sm_vote_yes", value)

					message = "%s voted yes." % (name)
					es.msg("#green", message)

				if choice == 2:
					value = es.ServerVar("sm_vote_no")
					value += 1
					es.set("sm_vote_no", value)

					message = "%s voted no." % (name)
					es.msg("#green", message)

				show_vote_time()

				players = es.ServerVar("sm_vote_players")
				if number >= players:
					end_vote()
			else:
				es.tell(userid, "#green", "You already voted.")
		else:
			es.tell(userid, "#green", "You can not vote.")
	else:
		es.tell(userid, "#green", "No vote active.")

def end_vote():
	yes = int(es.ServerVar("sm_vote_yes_percentage"))
	percentage = int(es.ServerVar("sm_vote_percentage"))
	if yes < percentage:
		es.msg("#green", "Not enough players voted yes.")
	else:
		block = es.ServerVar("sm_vote_block")
		es.doblock(block)

	delete_keygroup()

def delete_keygroup():
	exists = es.exists("keygroup", "sm_keygroup_vote")
	if exists == 1:
		es.keygroupdelete("sm_keygroup_vote")

def delete_popup():
	if popuplib.exists("sm_popup_vote"):
		popuplib.delete("sm_popup_vote")

def unload():
	delete_keygroup()
	delete_popup()